<?php
/*
* $Id: optWeight.php
* $Loc: /includes/hooks/admin/products_attributes/
*
* Name: AttributesWeight
* Version: 1.1
* Release Date: 2024-07-26
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under the GNU General Public License
*
* Comments: Author: [Rainer Schmied @raiwa]
* Author URI: [www.phoenixcartaddons.com]
* 
* CE Phoenix, E-Commerce made Easy
* https://phoenixcart.org
* 
* Copyright (c) 2021 Phoenix Cart
* 
* 
*/

class hook_admin_products_attributes_optWeight {

  public $version = '1.0';

    function listen_addProductOptionValuesAction() {

      $value_weight = Text::input($_POST['value_weight']);
      $value_weight_prefix = Text::input($_POST['value_weight_prefix']);

      $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_options_values
  SET products_options_values_weight = '%s',
      products_options_values_weight_prefix = '%s'
  WHERE products_options_values_id = %s
EOSQL
      , (float)$value_weight, $value_weight_prefix, (int)$GLOBALS['value_id']));

    }

    function listen_updateValueAction() {

      $value_weight = Text::input($_POST['value_weight']);
      $value_weight_prefix = Text::input($_POST['value_weight_prefix']);

      $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_options_values
  SET products_options_values_weight = '%s',
      products_options_values_weight_prefix = '%s'
  WHERE products_options_values_id = %s
EOSQL
      , (float)$value_weight, $value_weight_prefix, (int)$GLOBALS['value_id']));

    }

    function listen_addProductAttributesAction() {

      $option_weight = Text::input($_POST['option_weight']);
      $option_weight_prefix = Text::input($_POST['option_weight_prefix']);

      $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_attributes
  SET option_weight = '%s',
      option_weight_prefix = '%s'
  WHERE products_attributes_id = %s
EOSQL
      , (float)$option_weight, $option_weight_prefix, (int)$GLOBALS['products_attributes_id']));

    }

    function listen_updateProductAttributeAction() {

      $option_weight = Text::input($_POST['option_weight']);
      $option_weight_prefix = Text::input($_POST['option_weight_prefix']);

      $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_attributes
  SET option_weight = '%s',
      option_weight_prefix = '%s'
  WHERE products_attributes_id = %s
EOSQL
      , (float)$option_weight, $option_weight_prefix, (int)$GLOBALS['attribute_id']));

    }

  function listen_injectSiteStart() {
    global $action, $values_query, $attributes_query;

    // installation check
    if (mysqli_num_rows($GLOBALS['db']->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'option_weight'")) != 1 ) {
      $this->install_weight_support();
    }

  }

  function listen_injectSiteEnd() {
    global $action, $values_query, $attributes_query;

    $output = null;

    $attributes_values = $attributes_query->data_seek(0);

    $output = PHP_EOL . <<<EOD
<script>
$(function() {
EOD;

    $header_title_weight = TABLE_HEADING_OPT_WEIGHT;
    $header_title_weight_prefix = TABLE_HEADING_OPT_WEIGHT_PREFIX;

    $output .= PHP_EOL . <<<EOD
$('table:eq(0) thead tr th:nth-child(5)').after('<th class="text-right" style="width: 120px;">{$header_title_weight}</th><th class="text-center" style="width: 120px;">{$header_title_weight_prefix}</th>');
$('table:eq(0) thead tr th:nth-child(8)').css('width','140px');
EOD;

    $row_id = 0;
    while ( $attributes_values = $attributes_query->fetch_assoc() ) {

      if (($action == 'update_attribute') && ($_GET['attribute_id'] == $attributes_values['products_attributes_id'])) {
        $values_weight_input  = '<td class="text-right">';
        $values_weight_input .=   new Input('option_weight', ['value' => $attributes_values['option_weight']]);
        $values_weight_input .= '</td>';
        $values_weight_input .= '<td class="text-center">';
        $values_weight_input .=   new Input('option_weight_prefix', ['size' => 2, 'value' => $attributes_values['option_weight_prefix']]);
        $values_weight_input .= '</td>';

        $output .= PHP_EOL . <<<EOD
$('table:eq(0) tbody tr td input[name="price_prefix"]').closest('td').after('{$values_weight_input}');
EOD;
      } else {
        $values_weight_output  = '<td class="text-right">' . $attributes_values['option_weight'] . '</td>';
        $values_weight_output .= '<td class="text-center">' . $attributes_values['option_weight_prefix'] . '</td>';

        $output .= PHP_EOL . <<<EOD
$('table:eq(0) tbody tr:eq({$row_id}) td:nth-child(5)').after('{$values_weight_output}');
EOD;
      }
      $row_id ++;
    }

    if ($action != 'update_attribute') {

        $values_weight_input  = '<td class="text-right">';
        $values_weight_input .=  new Input('option_weight', ['value' => '0', 'disabled' => 'disabled']);
        $values_weight_input .= '</td>';
        $values_weight_input .= '<td class="text-right">';
        $values_weight_input .=  new Input('option_weight_prefix', ['value' => '+', 'disabled' => 'disabled']);
        $values_weight_input .= '</td>';

      $output .= PHP_EOL . <<<EOD
$('table:eq(0) tbody tr td input[name="price_prefix"]').closest('td').after('{$values_weight_input}');
EOD;

    }

    $output .= PHP_EOL . <<<EOD
$('table:eq(2) thead tr th:nth-child(3)').after('<th class="text-right">{$header_title_weight}</th><th class="text-center">{$header_title_weight_prefix}</th>');
$('table:eq(2) thead tr th:nth-child(2)').removeClass('w-25');
EOD;

    if (!empty($values_query)) {
      $values_values = $values_query->data_seek(0);
      $row_id = 0;
      while ($values_values = $values_query->fetch_assoc()) {

        if (($action == 'update_option_value') && ($_GET['value_id'] == $values_values['products_options_values_id'])) {

          $values_weight_input  = ' <div class="col-1">';
          $values_weight_input .= '  <div class="input-group mb-1">';
          $values_weight_input .=        new Input('value_weight', ['value' => $values_values['products_options_values_weight']]);
          $values_weight_input .= '  </div>';
          $values_weight_input .= ' </div>';
          $values_weight_input .= ' <div class="col-1">';
          $values_weight_input .= '  <div class="input-group mb-1">';
          $values_weight_input .=        new Input('value_weight_prefix', ['size' => 2, 'value' => $values_values['products_options_values_weight_prefix']]);
          $values_weight_input .= '  </div>';
          $values_weight_input .= ' </div>';

          $output .= PHP_EOL . <<<EOD
$('table:eq(2) tbody tr:eq({$row_id}) td div:nth-child(4)').before('{$values_weight_input}');
$('table:eq(2) tbody tr:eq({$row_id}) td div .col-4').toggleClass('col-4 col-2');
$('table:eq(2) tbody tr:eq({$row_id}) td[colspan=4]').attr('colspan', '6');
EOD;

        } else {
          $values_weight_output  = '<td class="text-right">' . $values_values['products_options_values_weight'] . '</td>';
          $values_weight_output .= '<td class="text-center">' . $values_values['products_options_values_weight_prefix'] . '</td>';

          $output .= PHP_EOL . <<<EOD
$('table:eq(2) tbody tr:eq({$row_id}) td:nth-child(3)').after('{$values_weight_output}');
EOD;

        }
        $row_id ++;
      }
    }

    if ($action != 'update_option_value') {
      $values_weight_input  = ' <div class="col-sm-1">';
      $values_weight_input .= '  <div class="input-group mb-1">';
      $values_weight_input .=      new Input('value_weight', ['value' => '0.00']);
      $values_weight_input .= '  </div>';
      $values_weight_input .= ' </div>';
      $values_weight_input .= ' <div class="col-sm-1">';
      $values_weight_input .= '  <div class="input-group mb-1">';
      $values_weight_input .=      new Input('value_weight_prefix', ['value' => '+']);
      $values_weight_input .= '  </div>';
      $values_weight_input .= ' </div>';

      $output .= PHP_EOL . <<<EOD
$('table:eq(2) tbody tr:last td div:nth-child(3)').after('{$values_weight_input}');
$('table:eq(2) tbody tr td div .col-4').toggleClass('col-4 col-2');
$('table:eq(2) tbody tr td[colspan=4]').attr('colspan', '6');
EOD;

    }

    $output .= PHP_EOL . <<<EOD
});
</script>
EOD;

    return $output;
  }

  public function listen_injectBodyEnd() {
    global $action;

    if ($action != 'update_attribute') {
      $helper_weight = <<<addat
<script>$('select[name="products_id"], select[name="options_id"], select[name="values_id"], input[name="option_weight_prefix"], input[name="option_weight"]').prop('required', true); $('select[name="products_id"]').change(function() { $('select[name="options_id"]').prop('disabled', false); }); $('select[name="options_id"]').change(function(){ $('select[name="values_id"]').prop('disabled', false); $('select[name="values_id"] option').show(); var id = $(this).val(); $('select[name="values_id"] option[data-id]:not([data-id*="' + id + '"])').hide(); }); $('select[name="values_id"]').change(function() { $('input[name="option_weight"], input[name="option_weight_prefix"]').prop('disabled', false); });</script>
addat;
      return $helper_weight;
    }
  }

  protected function install_weight_support () {
    global $db;

    // ADDED FIELDS
    if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'option_weight'")) != 1 ) {
      $db->query("AlTER TABLE products_attributes ADD option_weight decimal(5,2) NOT NULL");
    }
    if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'option_weight_prefix'")) != 1 ) {
      $db->query("AlTER TABLE products_attributes ADD option_weight_prefix char(1) NOT NULL");
    }
    // ADD FIELD for options values weight
    if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_options_values' AND COLUMN_NAME LIKE 'products_options_values_weight'")) != 1 ) {
      $db->query("AlTER TABLE products_options_values ADD products_options_values_weight decimal(5,2) NOT NULL");
    }
    if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_options_values' AND COLUMN_NAME LIKE 'products_options_values_weight_prefix'")) != 1 ) {
      $db->query("AlTER TABLE products_options_values ADD products_options_values_weight_prefix char(1) NOT NULL");
    }

    Href::redirect(Guarantor::ensure_global('Admin')->link());

  }

}
